#!/usr/bin/python
# -*- coding: utf-8 -*-

import os
import sys
import os.path


def createPackagesInRelease():
    """
    Получить мап <пакет>:<версия> текущего релиза
    """
    packs = {}
    if os.path.isfile('/linuxcash/cash/data/upgrade-system/artix-packages.version'):
        tmp = [line.strip() for line in open('/linuxcash/cash/data/upgrade-system/artix-packages.version')]
        for a in tmp:
            b = a.split('=')
            if len(b) > 1:
                packs[b[0]] = b[1]
    return packs

def getPackagesWithVersion(text, packInRelease):
    """
    Получить список пакетов с версиями из строки
    """
    packages = []
    for pack in text.split(" "):
        if pack in packInRelease:
            packages.append("%s_%s" % (pack, packInRelease[pack]))
    return packages

fileName = str(sys.argv[1])

if not os.path.isfile(fileName):
    print("File not exist %s" % fileName)
    exit()

packInRelease = createPackagesInRelease()

result = []
lines = [line.strip() for line in open(fileName)]

k = 0
while k < len(lines):
    if lines[k] == 'The following NEW packages will be installed:':
        result += getPackagesWithVersion(lines[k + 1].replace("{a}", ""), packInRelease)

    if lines[k] == 'The following packages will be upgraded:':
        result += getPackagesWithVersion(lines[k + 1], packInRelease)

    if lines[k] == 'Downgrade the following packages:':
        while k + 1 < len(lines) and lines[k + 1] != "":
            tmp1 = lines[k + 1].split()
            if len(tmp1) < 6:
                break
            result.append("%s_%s" % (tmp1[1], tmp1[5]))
            k += 1
    k += 1

print(" ".join(result))
